package kr.co.vividnext.sodalive.admin.audition.applicant

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.DeleteMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/audition/applicant")
class AdminAuditionApplicantController(private val service: AdminAuditionApplicantService) {
    @DeleteMapping("/{id}")
    fun deleteAuditionApplicant(@PathVariable id: Long) = ApiResponse.ok(
        service.deleteAuditionApplicant(id),
        "오디션 지원이 취소 되었습니다."
    )
}
