package kr.co.vividnext.sodalive.admin.point

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.data.domain.Pageable
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/admin/point-policies")
@PreAuthorize("hasRole('ADMIN')")
class PointPolicyController(private val service: PointPolicyService) {
    @GetMapping
    fun getAll(pageable: Pageable) = ApiResponse.ok(
        service.getAll(
            offset = pageable.offset,
            limit = pageable.pageSize.toLong()
        )
    )

    @PostMapping
    fun create(
        @RequestBody request: CreatePointRewardPolicyRequest
    ) = ApiResponse.ok(service.create(request))

    @PutMapping("/{id}")
    fun update(
        @PathVariable id: Long,
        @RequestBody request: ModifyPointRewardPolicyRequest
    ) = ApiResponse.ok(service.update(id, request))
}
