package kr.co.vividnext.sodalive.alarm

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.can.use.CanUsage
import kr.co.vividnext.sodalive.can.use.QUseCan.useCan
import org.springframework.stereotype.Repository

@Repository
class AlarmRepository(private val queryFactory: JPAQueryFactory) {
    fun getSlotQuantity(memberId: Long): Int {
        return queryFactory
            .select(useCan.id)
            .from(useCan)
            .where(
                useCan.member.id.eq(memberId)
                    .and(useCan.isRefund.isFalse)
                    .and(useCan.canUsage.eq(CanUsage.ALARM_SLOT))
            )
            .fetch()
            .size
    }
}
